;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; A simple convenience procedure for changing directories.
;;;
;;; Also reexports `current-directory` from the posix unit.
;;;
;;; Written by Evan Hanson <evhan@foldling.org> and placed in the Public
;;; Domain. All warranties are disclaimed.
;;;

(declare
  (module with-current-directory)
  (import posix)
  (export with-current-directory current-directory))

(define (with-current-directory path thunk)
  (let ((orig (current-directory)))
    (dynamic-wind
     (lambda () (current-directory path))
     thunk
     (lambda () (current-directory orig)))))
